package com.ruoyi.app.service;

import java.util.List;

import com.ruoyi.app.model.Supplier;
import com.ruoyi.app.model.request.ReqSupplierList;

/**
 * 供应商Service接口
 * 
 * @author coede
 * @date 2025-03-19
 */
public interface ISupplierService 
{
    /**
     * 查询供应商
     * 
     * @param id 供应商主键
     * @return 供应商
     */
    public Supplier selectSupplierById(Long id);

    /**
     * 查询供应商列表
     * 
     * @param req 供应商
     * @return 供应商集合
     */
    public List<Supplier> selectSupplierList(ReqSupplierList req);

    /**
     * 查询全部供应商列表
     *
     *
     * @return 供应商集合
     */
    public List<Supplier> selectAllSupplierList();

    /**
     * 校验供应商名称是否唯一
     *
     * @param  supplier 供应商
     * @return 结果
     */
    public boolean checkSupplierNameUnique(Supplier supplier);

    /**
     * 校验供应商编号是否唯一
     *
     * @param supplier 供应商
     * @return 结果
     */
    public boolean checkSupplierNoUnique(Supplier supplier);

    /**
     * 新增供应商
     * 
     * @param supplier 供应商
     * @return 结果
     */
    public int insertSupplier(Supplier supplier);

    /**
     * 修改供应商
     * 
     * @param supplier 供应商
     * @return 结果
     */
    public int updateSupplier(Supplier supplier);


    /**
     * 批量删除供应商
     * 
     * @param ids 需要删除的供应商主键集合
     * @return 结果
     */
    public int deleteSupplierByIds(Long[] ids);

    /**
     * 删除供应商信息
     * 
     * @param id 供应商主键
     * @return 结果
     */
    public int deleteSupplierById(Long id);

    /**
     * 获取下一个自动生成的供应商编号
     * @return
     */
    public String getNextNo();


}
